---
title: RTCSessionDescription()
slug: Web/API/RTCSessionDescription/RTCSessionDescription
tags:
  - Constructor
  - Deprecated
  - Experimental
  - Media
  - RTCSessionDescription
  - Reference
  - SDP
  - WebRTC
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}{{deprecated_header}}</p>

<p>The <strong><code>RTCSessionDescription()</code></strong> constructor creates a new {{domxref("RTCSessionDescription")}} with its properties initialized as described in the specified object.</p>

<div class="note">
<p>This constructor has been deprecated because {{domxref("RTCPeerConnection.setLocalDescription()")}} and other methods which take SDP as input now directly accept an object conforming to the <code>RTCSessionDescriptionInit</code> dictionary, so you don't have to instantiate an <code>RTCSessionDescription</code> yourself.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> <em>sessionDescription</em> = new RTCSessionDescription(<em>rtcSessionDescriptionInit</em>);</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>rtcSessionDescriptionInit</code><em> </em>{{optional_inline}}</dt>
 <dd>An object providing the default values for the session description; the object conforms to the <code>RTCSessionDescriptionInit</code> dictionary. That dictionary has the following properties:
 <dl>
  <dt><code>type</code></dt>
  <dd><strong>Required</strong><strong>.</strong> A string which is a member of the <code>RTCSdpType</code> enum; it must have one of the following values:
  <div>{{page("/en-US/docs/Web/API/RTCSessionDescription", "RTCSdpType")}}</div>
  </dd>
  <dt><code>sdp</code></dt>
  <dd>A string containing a {{Glossary("SDP")}} message describing the session. This value is an empty string (<code>""</code>) by default and may not be <code>null</code>.</dd>
 </dl>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example uses the constructor to convert an SDP offer into an <code>RTCSessionDescription</code> object.</p>

<div class="note">
<p>This is no longer necessary, however; {{domxref("RTCPeerConnection.setLocalDescription()")}} and other methods which take SDP as input now directly accept an object conforming to the <code>RTCSessionDescriptionInit</code> dictionary, so you don't have to instantiate an <code>RTCSessionDescription</code> yourself.</p>
</div>

<pre class="brush: js">navigator.getUserMedia({video: true}, function(stream) {
  pc.onaddstream({stream: stream});
  // Adding a local stream won't trigger the onaddstream callback
  pc.addStream(stream);

  pc.createOffer(function(offer) {
    pc.setLocalDescription(new RTCSessionDescription(offer), function() {
      // send the offer to a server to be forwarded to the friend you're calling.
    }, error);
  }, error);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table" style="height: 49px; width: 1000px;">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#widl-ctor-RTCSessionDescription--RTCSessionDescriptionInit-descriptionInitDict', 'RTCSessionDescription()') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCSessionDescription.RTCSessionDescription")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC_API">WebRTC API</a></li>
 <li>{{domxref("RTCSessionDescription")}}</li>
</ul>
